local myname="ZifnabsBufmon"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={bufmon=Me} else ZifnabsMod.bufmon=Me end
local mod
local L
local db
local PLAYERNAME=UnitName("player")
local MAXPETBUFFS=7
local targets={"player","playerpet","party1","party2","party3","party4","party1pet","party2pet","party3pet","party4pet"}
local fkey={player="1",playerpet="1 Pet",party1="2",party2="3",party3="4",party4="5",party1pet="2 Pet",party2pet="3 Pet",party3pet="4 Pet",party4pet="5 Pet"}
local mydb
local lastbuffs={}
local widget={}

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	mod=fwinfo.mod
	L=fwinfo.L
	db=fwinfo.db
	if not db.bufmon then db.bufmon={} end
	if not db.bufmon[PLAYERNAME] then 
		db.bufmon[PLAYERNAME]={active=true, minduration=300, fadingtime=15, warnfading=true, warnfaded=true, showpets=true, warnmybufs=true, warnbufs2me=true} 
	end
	mydb=db.bufmon[PLAYERNAME]		
end

function Me:PostInit()
	widget.pet={}
	for p=1,4,1 do
		widget.pet[p]=mod.ui:newFrame(myname.."_Pet_"..p,24,24,UIParent,"TOPLEFT","TOPLEFT",20,-100-80*p,{transparent=true})
		widget.pet[p].head=mod.ui:newButton(myname.."_Pet_"..p.."_head",20,20,widget.pet[p],"TOPLEFT","TOPLEFT",0,0,{inherit="Zifnabs_MM",click=Me.TargetPet})
		widget.pet[p].head:SetBackdrop(nil)
		widget.pet[p].head:SetNormalTexture(nil)
		widget.pet[p].life100=mod.ui:newButton(myname.."_Pet_"..p.."_life100",60,4,widget.pet[p],"TOPLEFT","TOPLEFT",25,0,{inherit="Zifnabs_MM"})
		widget.pet[p].life100:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil});
		widget.pet[p].life100:SetNormalTexture(nil)
		widget.pet[p].life100:SetBackdropColor(0,0,0)
		widget.pet[p].life=mod.ui:newButton(myname.."_Pet_"..p.."_life",50,4,widget.pet[p].life100,"TOPLEFT","TOPLEFT",0,0,{inherit="Zifnabs_MM"})
		widget.pet[p].life:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = nil});
		widget.pet[p].life:SetNormalTexture(nil)
		widget.pet[p].life:SetBackdropColor(0,1,0)
		widget.pet[p].buf={}
		for buf=1,MAXPETBUFFS,1 do
			widget.pet[p].buf[buf]=mod.ui:newButton(myname.."_Pet_"..p.."_buf_"..buf,10,10,widget.pet[p].life100,"BOTTOMLEFT","TOPLEFT",11*buf-11,-1,{inherit="Zifnabs_MM"})
			widget.pet[p].buf[buf]:SetBackdrop(nil)
			widget.pet[p].buf[buf]:SetNormalTexture(nil)
		end
	end
	Me:Activate(mydb.active)
end
	
function Me:Activate(set)
	if set then 
		mod.core:Register4Event("TICK","bufmon",Me.Tick) 
	else 
		mod.core:DeRegister4Event("TICK","bufmon",Me.Tick) 
	end
end

-- --------------------------------------------------------------------------------------
-- TICK
-- --------------------------------------------------------------------------------------
function Me:Tick(elapsed,online)
	local buffs={}
	-- Monitor Buffs
	for dummynr,target in ipairs(targets) do
		if UnitExists(target) and (target=="player" or target=="playerpet" or mydb.warnpartybufs) then
			local uname=UnitName(target)
			buffs[uname]={}
			-- Weapon Enchants
			if target=="player" then
				local main,mainexpire,maincharges,mainid,off,offexpire,offcharges,offid=GetWeaponEnchantInfo()
				if main then
					rest=mainexpire-GetTime()
					buffs[uname][L.word.mainhand]={rest=rest,caster="player",castername=PLAYERNAME,icon=mainid,duration=math.max(600,rest)}
					Me:CheckWarnFading(uname,L.word.mainhand,"player","player",mainid,rest)
					if lastbuffs[uname] and lastbuffs[uname][L.word.mainhand] then lastbuffs[uname][L.word.mainhand].notfaded=true end
				end
				if off then
					rest=offexpire-GetTime()
					buffs[uname][L.word.offhand]={rest=rest,caster="player",castername=PLAYERNAME,icon=offid,duration=math.max(600,rest)}
					Me:CheckWarnFading(uname,L.word.offhand,"player","player",offid,rest)
					if lastbuffs[uname] and lastbuffs[uname][L.word.offhand] then lastbuffs[uname][L.word.offhand].notfaded=true end
				end
			end
			for nr=1,40,1 do	
				local name,icon,rank,bufftype,duration, expire, caster=UnitAura(target,nr)
				if not name then break end
				-- Buffs auf andere zeigen leider keine duration und expiration an. So "wächst" die beobachtete Dauer wenigstens über die Zeit				
				if duration==0 and lastbuffs[uname] and lastbuffs[uname][name] then 
					duration=lastbuffs[uname][name].duration+elapsed 
				end
				local rest=expire-GetTime()
				local castername=nil
				if caster then castername=UnitName(caster) end
				buffs[uname][name]={rest=rest,caster=caster,castername=castername,icon=icon,duration=duration}
				if lastbuffs[uname] and lastbuffs[uname][name] then lastbuffs[uname][name].notfaded=true 
				elseif db.bufmon.debug then mod.f:Debug("Neu "..name.." von "..(castername or caster or "nil").." auf "..target.." ("..uname..")") end
				if duration>=mydb.minduration and (caster=="player" or (target=="player" and (UnitInParty(caster) or UnitInRaid(caster)) and mydb.warnbufs2me)) then
					Me:CheckWarnFading(uname,name,target,caster,icon,rest)
				end
			end
			if mydb.warnfaded then 
				for name,info in pairs(lastbuffs[uname] or {}) do 
					if not info.notfaded and info.duration>=mydb.minduration then Me:Warnmsg(L.msg.buffaded,name,target,info.caster,info.icon)
					elseif db.bufmon.debug and not info.notfaded then mod.f:Debug("ignoriere ausgelaufenen "..name.." auf "..(target or "nil")..", rest="..info.rest..", duration="..math.floor(info.duration)) end
				end
			end
			lastbuffs[uname]=buffs[uname]
		end
	end
	-- Show Pets of Group
	if mydb.showpets then
		for nr=1,4,1 do
			local pet="party"..nr.."pet"
			if UnitExists(pet) then
				local health=UnitHealth(pet)
				local maxhealth=UnitHealthMax(pet)
				widget.pet[nr].head:SetNormalTexture(peticon or 135792) -- TODO PET ICON einsetzen
				widget.pet[nr].head.petid=pet
				widget.pet[nr].head.tooltipText=UnitName(pet) or "Pet "..nr
				widget.pet[nr].head:Show()
				widget.pet[nr].life:SetWidth(math.min(60,math.max(1,60*health/maxhealth)))
				widget.pet[nr].life.tooltipText=health.."/"..maxhealth
				widget.pet[nr].life100.tooltipText=health.."/"..maxhealth
				widget.pet[nr].life100:Show()
				widget.pet[nr].life:Hide()
				widget.pet[nr].life:Show()
				local pb=0
				for btn=1,2,1 do
					for buf=1,40,1 do	
						local name,icon,wtf=UnitBuff(pet,buf)
						if btn==2 then name,icon,wtf=UnitDebuff(pet,buf) end
						if name and pb<MAXPETBUFFS then
							pb=pb+1
							widget.pet[nr].buf[pb]:SetNormalTexture(icon)
							widget.pet[nr].buf[pb].tooltipText=name
							widget.pet[nr].buf[pb]:Show()
						end
					end
				end
				if pb<MAXPETBUFFS then for h=pb+1,MAXPETBUFFS,1 do widget.pet[nr].buf[h]:Hide() end end
				widget.pet[nr]:Show()
			elseif widget.pet[nr]:IsVisible() then 
				widget.pet[nr]:Hide()
				-- Der Rest ist BESCHEUERT! Das sollte alles mit dem Frame versteckt werden!
				widget.pet[nr].head:Hide()
				widget.pet[nr].life:Hide()
				widget.pet[nr].life100:Hide()
				for buf=1,MAXPETBUFFS,1 do widget.pet[nr].buf[buf]:Hide() end
			end
		end
	end
end

function Me:CheckWarnFading(uname,name,target,caster,icon,rest)
	if mydb.warnfading and mydb.fadingtime>0 and rest>0 and rest<=mydb.fadingtime and lastbuffs[uname] and lastbuffs[uname][name] and lastbuffs[uname][name].rest>mydb.fadingtime then 
		Me:Warnmsg(L.msg.buffading,uname,name,target,caster,icon)
elseif db.bufmon.debug then
local lbr=nil
if lastbuffs[uname] and lastbuffs[uname][name] then lbr=lastbuffs[uname][name].rest end
if rest<=mydb.fadingtime then mod.f:Debug(name.." rest="..rest..", lastbuff-rest="..(lbr or "nil")) end
	end
end

-- --------------------------------------------------------------------------------------
-- WARN MESSAGE
-- --------------------------------------------------------------------------------------
function Me:Warnmsg(msg,uname,buf,target,caster,icon)
	if UnitExists(caster) then
		local tgt="("..mod.f:Color(fkey[target],"ff4040")..") "
		if target~="player" then tgt=uname..tgt end
		local castby=""
		if caster and caster~="player" then castby=" ("..L.word.by.." "..(UnitName(caster) or caster or "")..")" end
		mod.hud:write(tgt..mod.f:Repl(msg,{buf=buf})..castby,"dingding.mp3",icon)
	end
end

-- --------------------------------------------------------------------------------------
-- TARGET PET
-- --------------------------------------------------------------------------------------
function Me:TargetPet(button,parse) 
	print("targeting "..(button.petid or "nil"))
	TargetUnit(button.petid) 
end


-- --------------------------------------------------------------------------------------
-- IDENTIFY CONFIG FRAMES
-- --------------------------------------------------------------------------------------
function Me:IdentifyConfigs() return {[1]=L.config.bufmon} end

-- --------------------------------------------------------------------------------------
-- START CONFIG
-- --------------------------------------------------------------------------------------
function Me:StartConfig(frame)
	config={changed=false}
	if not widget.config then
		widget.config={}
		widget.config.active=mod.ui:newCheck(myname.."_active",20,20,frame,"TOPLEFT","TOPLEFT",20,-10,{text=L.config.bufmon.." "..L.word.active,check=mydb.active,click=Me.ConfigChange})
		widget.config.minduration=mod.ui:newSlider(myname.."_minduration",200,20,frame,"TOPLEFT","TOPLEFT",20,-50,{min=0,max=600,text=L.word.minduration,val=mydb.minduration,click=Me.ConfigChange})
		widget.config.warnfaded=mod.ui:newCheck(myname.."_warnfaded",20,20,frame,"TOPLEFT","TOPLEFT",20,-90,{text=L.word.warnfaded,check=mydb.warnfaded,click=Me.ConfigChange})
		widget.config.warnfading=mod.ui:newCheck(myname.."_warnfading",20,20,frame,"TOPLEFT","TOPLEFT",20,-110,{text=L.word.warnfading,check=mydb.warnfading,click=Me.ConfigChange})
		widget.config.fadingtime=mod.ui:newSlider(myname.."_fadingtime",200,20,frame,"TOPLEFT","TOPLEFT",20,-145,{min=0,max=60,text=L.word.fadingtime,val=mydb.fadingtime,click=Me.ConfigChange})
		widget.config.warnmybufs=mod.ui:newCheck(myname.."_warnmybufs",20,20,frame,"TOPLEFT","TOPLEFT",20,-220,{text=L.word.warnmybufs,check=mydb.warnmybufs,click=Me.ConfigChange})
		widget.config.warnbufs2me=mod.ui:newCheck(myname.."_warnbufs2me",20,20,frame,"TOPLEFT","TOPLEFT",20,-240,{text=L.word.warnbufs2me,check=mydb.warnbufs2me,click=Me.ConfigChange})
		widget.config.showpets=mod.ui:newCheck(myname.."_showpets",20,20,frame,"TOPLEFT","TOPLEFT",20,-270,{text=L.word.showpets,check=mydb.showpets,click=Me.ConfigChange})
	else
		widget.config.active:SetChecked(mydb.active)
		widget.config.minduration:SetValue(mydb.minduration)
		widget.config.warnfading:SetChecked(mydb.warnfading)
		widget.config.fadingtime:SetValue(mydb.fadingtime)
		widget.config.warnfaded:SetChecked(mydb.warnfaded)
		widget.config.showpets:SetChecked(mydb.showpets)
		widget.config.warnmybufs:SetChecked(mydb.warnmybufs)
		widget.config.warnbufs2me:SetChecked(mydb.warnbufs2me)
	end
end

-- --------------------------------------------------------------------------------------
-- CONFIG CHECK FOR CHANGES
-- --------------------------------------------------------------------------------------
function Me:ConfigChange(button,parse)
	config.changed=(widget.config.active:GetChecked()~=mydb.active)
	config.changed=config.changed or (widget.config.minduration:GetValue()~=mydb.minduration)
	config.changed=config.changed or (widget.config.fadingtime:GetValue()~=mydb.fadingtime)
	config.changed=config.changed or (widget.config.warnfading:GetChecked()~=mydb.warnfading)
	config.changed=config.changed or (widget.config.warnfaded:GetChecked()~=mydb.warnfaded)
	config.changed=config.changed or (widget.config.showpets:GetChecked()~=mydb.showpets)
	config.changed=config.changed or (widget.config.warnmybufs:GetChecked()~=mydb.warnmybufs)
	config.changed=config.changed or (widget.config.warnbufs2me:GetChecked()~=mydb.warnbufs2me)
	mod.core:SetUnsavedChanges(config.changed)
end

-- --------------------------------------------------------------------------------------
-- SAVE CONFIG
-- --------------------------------------------------------------------------------------
function Me:SaveConfig(frame)
	mydb.active=widget.config.active:GetChecked()
	mydb.minduration=widget.config.minduration:GetValue()
	mydb.fadingtime=widget.config.fadingtime:GetValue()
	mydb.warnfading=widget.config.warnfading:GetChecked()
	mydb.warnfaded=widget.config.warnfaded:GetChecked()
	mydb.showpets=widget.config.showpets:GetChecked()
	mydb.warnmybufs=widget.config.warnmybufs:GetChecked()
	mydb.warnbufs2me=widget.config.warnbufs2me:GetChecked()
	config.changed=false
	Me:Activate(mydb.active)
	return true
end

-- --------------------------------------------------------------------------------------
-- IGNORE CONFIG
-- --------------------------------------------------------------------------------------
function Me:IgnoreConfig(frame) 
	Me:StartConfig(frame)
	return true 
end