local myname="ZifnabsEmotor"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={emotor=Me} else ZifnabsMod.emotor=Me end
local fw
local mod
local C
local L
local db
local dbpc

local SOULSTONE_TIME=30*60
local PLAYERNAME=UnitName("player").." "..GetRealmName()
local reaction={precheck={}}
local summon
local state={infight=false,fishing=false}
local unknownspell={}
local widget={}
local last={}
local lastspell=nil
local config={}

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	fw=fwinfo
	mod=fwinfo.mod
	C=fwinfo.C
	L=fwinfo.L
	db=fwinfo.db
	dbpc=fwinfo.dbpc
	if not db.emotor or not db.emotor.cmd.HI or type(db.emotor.cmd.HI.option.react)~="table" then db.emotor={cmd={},hesheit={},pet={}, nosexfound={}} end
	
	for cmd,data in pairs(L.emotor.cmd) do
		if not db.emotor.cmd[cmd] then
			db.emotor.cmd[cmd]=data
			mod.f:PrintR(L.msg.cmdinserted,{cmd=cmd})
		end
	end
	for key,data in pairs(L.emotor.hesheit) do
		if not db.emotor.hesheit[key] then
			db.emotor.hesheit[key]=data
			mod.f:PrintR(L.msg.hsiinserted,{key=key})
		end
	end
		
	widget.mute=mod.ui:newControlButton(2,myname.."_Mute",{click=Me.Mute})
	Me:Mute("set",db.gatherer.muted)

	mod.core:Register4Event("PLAYER_REGEN_DISABLED","emotor",Me.PLAYER_REGEN_DISABLED)
	mod.core:Register4Event("PLAYER_REGEN_ENABLED","emotor",Me.PLAYER_REGEN_ENABLED)
	mod.core:Register4Event("UNIT_SPELLCAST_START","emotor",Me.SPELLCAST_START)
	mod.core:Register4Event("UNIT_SPELLCAST_CHANNEL_START","emotor",Me.SPELLCAST_CHANNEL_START)
	mod.core:Register4Event("UNIT_SPELLCAST_CHANNEL_STOP","emotor",Me.SPELLCAST_CHANNEL_STOP)
	mod.core:Register4Event("UNIT_SPELLCAST_SUCCEEDED","emotor",Me.UNIT_SPELLCAST_SUCCEEDED)
	mod.core:Register4Event("ONUPDATE","emotor",Me.OnUpdate)

	BINDING_NAME_ZIFNABS_EMOTOR_HI    = L.keybind.emotor.hi
	BINDING_NAME_ZIFNABS_EMOTOR_BYE   = L.keybind.emotor.bye
	BINDING_NAME_ZIFNABS_EMOTOR_SORRY = L.keybind.emotor.sorry
	BINDING_NAME_ZIFNABS_EMOTOR_THANK = L.keybind.emotor.thank
	BINDING_NAME_ZIFNABS_EMOTOR_CHEER = L.keybind.emotor.cheer
	BINDING_NAME_ZIFNABS_EMOTOR_CRY   = L.keybind.emotor.cry  
	BINDING_NAME_ZIFNABS_EMOTOR_SIGH  = L.keybind.emotor.sigh
	BINDING_NAME_ZIFNABS_EMOTOR_WAVE  = L.keybind.emotor.wave
end

function Me:PostInit()
	for name,data in pairs(db.emotor.nosexfound) do
		if not Me:GetSex(name,"initcheck") then 
			if mod.targets.Seen(name) then mod.f:PrintR(L.msg.nosexfound,{target=name})
			else db.emotor.nosexfound[name]="nil" end -- offenbar ein "Falschläufer"
		else
			db.emotor.nosexfound[name]=nil
			mod.f:PrintR(L.msg.sexfound,{target=name})
		end
	end
end

-- --------------------------------------------------------------------------------------
-- ON UPDATE
-- --------------------------------------------------------------------------------------
function Me:OnUpdate()
	if summon then
		if UnitCreatureFamily("pet")==summon.family then
			if not dbpc.petname then dbpc.petname={} end
			dbpc.petname[summon.slot]=UnitName("pet")
			summon=nil
		elseif time()-summon.start>11 then
			summon=nil
		end
	end
end

-- --------------------------------------------------------------------------------------
-- PLAYER REGEN ENABLED/DISABLED
-- --------------------------------------------------------------------------------------
function Me:PLAYER_REGEN_DISABLED() 
	state.infight=true
	if state.fishing then Me:Command(L.word.FISHING_ATTACKED) end
end
function Me:PLAYER_REGEN_ENABLED() state.infight=false end

-- --------------------------------------------------------------------------------------
-- SPELLCAST_START
-- --------------------------------------------------------------------------------------
function Me:SPELLCAST_START(who,spellid,rank,more) Me:AnyCast(who,spellid,rank,"cast") end

-- --------------------------------------------------------------------------------------
-- SPELLCAST_CHANNEL_START
-- --------------------------------------------------------------------------------------
function Me:SPELLCAST_CHANNEL_START(who,spellid,rank,more) Me:AnyCast(who,spellid,rank,"channel") end

-- --------------------------------------------------------------------------------------
-- SPELLCAST_CHANNEL_STOP
-- --------------------------------------------------------------------------------------
function Me:SPELLCAST_CHANNEL_STOP(who,spellid,rank,more)
	local spell,srank,icon,casttime,minrange,maxrange=GetSpellInfo(rank)	
	if spell==L.word.FISHING then state.fishing=false end
end

-- --------------------------------------------------------------------------------------
-- SPELLCAST_SUCCEEDED
-- --------------------------------------------------------------------------------------
function Me:UNIT_SPELLCAST_SUCCEEDED(who,spellid,rank) Me:AnyCast(who,spellid,rank,"succeed") end

-- --------------------------------------------------------------------------------------
-- ANY CAST
-- --------------------------------------------------------------------------------------
function Me:AnyCast(who,spellid,rank,casttype)
	if casttype=="succeed" and rank==lastspell then return end
	lastspell=rank
	local spell,srank,icon,casttime,minrange,maxrange=GetSpellInfo(rank)	
	local list=nil
	local pet=nil
	if who=="player" and spell and db.emotor.cmd[spell] then 
		-- Angeln
		if spell==L.word.FISHING then
			state.fishing=true
			local x,y,z,pos=mod.loc:GetLoc()
			if not reaction.precheck or not reaction.precheck.FISHING or mod.loc:Distance(pos,reaction.precheck.FISHING.loc)>0.2 or time()-reaction.precheck.FISHING.time>300 then spell=spell.." 1" end
			reaction.precheck.FISHING={time=time(),loc=pos}
		end
		-- Seelenstein setzen
		if spell==L.word.SET_SOULSTONE then
			mod.scheduler:add(SOULSTONE_TIME-60,"SSS-60","*.mod.hud:write(*.mod.f:Repl(*.L.msg.soulstonefade,{rest=60}),\"SOULSTONEOUT\")")
			list="SELF"
			for party=1,5,1 do
				if UnitName("party"..party) and UnitName("target")==UnitName("party"..party) then list="TARGET" end
			end
		end
		Me:Command(spell,nil,list)
	else
		if who=="player" and not unknownspell[spell] then unknownspell[spell]={rank=rank,casttype=casttype,spellid=spellid} end
		if who=="player" and db.emotor.debug and time()-(unknownspell[spell].last or 0)>180 then 
			mod.f:Debug(L.msg.unknownspell,{spell=spell,cast=(casttype or "")}) 
			unknownspell[spell].last=time()
		end
	end
end

-- --------------------------------------------------------------------------------------
-- COMMAND
-- --------------------------------------------------------------------------------------
function Me:Command(cmd,parm,list)
	local ucmd=string.upper(cmd)
	local uparm=string.upper(parm or "")
		
	list=list or "NOTARGET"
	pet=pet or UnitName("pet") or ""
	local skipemotes=false
	
	-- Pet Aktion
	if ucmd=="PET" then
		if not UnitExists("pet") or string.upper(parm)=="PASSIVE" and not state.infight then
			cmd=nil
		else
			local lclass,class,dummy=UnitClass("player")
			if class=="WARLOCK" then 
				ucmd="DEMON" 
				-- TODO eventuell noch spezialisieren auf IMP/VOID/SUCCUBUS/FELHOUND
			end
			cmd=ucmd.."_"..string.upper(parm)
		end
	end
	
	if not db.emotor.cmd[cmd] then cmd=ucmd end
	
	if not cmd then nothing=nil
	elseif string.sub(cmd,1,1)=="/" then DoEmote(string.sub(cmd,2))
	elseif not db.emotor.cmd[cmd] then mod.f:PrintR(L.msg.unknowncmd,{cmd=cmd})
	elseif db.emotor.muted and not db.emotor.cmd[cmd].unmutable then nothing=nil
	elseif not reaction[cmd] or time()-reaction[cmd].time>=(db.emotor.cmd[cmd].option.mute[PLAYERNAME] or db.emotor.cmd[cmd].option.mute.default) then
		if list=="NOTARGET" and UnitExists("target") and db.emotor.cmd[cmd].TARGET then
			list="TARGET"
			if UnitCanAttack("player","target") and db.emotor.cmd[cmd].ENEMY then list="ENEMY" end
			if list=="ENEMY" and cmd=="THANK" and (state.infight or UnitIsDead("target")) then 
				list="NOTARGET" 
				skipemotes=true
			end
			if UnitIsPlayer("target") then 
				local classify=mod.targets:Classify(UnitName("target"))
				if classify and db.emotor.cmd[cmd][classify] then list=classify end
			end
		end
		local selectedemo=""
		local selectedsay=""
		local react=db.emotor.cmd[cmd].option.react[PLAYERNAME] or db.emotor.cmd[cmd].option.react.default or 100
		if math.random(99)<react and db.emotor.cmd[cmd][list] then
			local say=Me:Add2Selectable({},"say",db.emotor.cmd[cmd][list].say,cmd,list)
			local emo=Me:Add2Selectable({},"emo",db.emotor.cmd[cmd][list].emo,cmd,list,skipemotes)
			if db.emotor.cmd[cmd].option.chain then
				local chain=mod.f:Split(db.emotor.cmd[cmd].option.chain,"[.]",2)
				if not chain[2] then chain[2]=list end
				if db.emotor.cmd[chain[1]] and db.emotor.cmd[chain[1]][chain[2]] then
					say=Me:Add2Selectable(say,"say",db.emotor.cmd[chain[1]][chain[2]].say,cmd,list)
					emo=Me:Add2Selectable(emo,"emo",db.emotor.cmd[chain[1]][chain[2]].emo,cmd,list,skipemotes)
				end
			end
			local language=nil -- TODO irgendwo einen Sprachenschalter einbauen?
			if #say>0 then selectedsay=Me:TakeRandomFrom(say,"say."..cmd.."."..list) else mod.f:PrintR(L.msg.emptylist,{list=cmd.."."..list..".say"}) end
			if #emo>0 then selectedemo=Me:TakeRandomFrom(emo,"emo."..cmd.."."..list) else mod.f:PrintR(L.msg.emptylist,{list=cmd.."."..list..".emo"}) end
			local concat=string.find(selectedsay,"&&")
			if concat then
				selectedemo=string.sub(selectedsay,concat+2)
				if concat>1 then selectedsay=string.sub(selectedsay,1,concat-1) else selectedsay="" end
			end
			selectedsay=Me:ReplaceKeysWithSex(selectedsay)
			selectedemo=Me:ReplaceKeysWithSex(selectedemo)
			
			local repl={[".race"]=UnitRace("target") or UnitCreatureFamily("target") or UnitClass("target") or "Whatever"}
			repl.pet=UnitName("playerpet")
			-- Dämon beschwören
			if db.emotor.cmd[cmd].option and db.emotor.cmd[cmd].option.summon then
				local demon=db.emotor.cmd[cmd].option.summon
				if L.word[demon] then 
					repl.pet=L.word[demon]
					summon={slot=demon,family=pet,start=time()}
					if dbpc.petname and dbpc.petname[demon] then repl.pet=dbpc.petname[demon] end
				end
			end
			-- Magier Teleport / Portal
			if db.emotor.cmd[cmd].option and db.emotor.cmd[cmd].option.city then
				local parse=mod.f:Split(spell,":")
				if #parse==2 then repl.city=parse[2] end
			end
			for from,into in pairs(repl) do
				if selectedsay then selectedsay=mod.f:Repl(selectedsay,repl) end
				if selectedemo then selectedemo=mod.f:Repl(selectedemo,repl) end
			end			
			
			if string.sub(selectedemo,1,1)=="/" then DoEmote(string.sub(selectedemo,2)) else SendChatMessage(selectedemo,"EMOTE") end
			local channel="SAY"
			if strlower(strsub(selectedsay,1,3))=="/y " then
				selectedsay=strtrim(strsub(selectedsay,3))
				channel="YELL"
			end
			SendChatMessage(selectedsay,channel,GetLanguageByIndex(language or 1))

			local x,y,z,pos=mod.loc:GetLoc()
			reaction[cmd]={time=time(),loc=pos}
		end
	end
end

function Me:TakeRandomFrom(tbl,lastid)
	local take=tbl[math.random(#tbl)].text
	if not take then 
		print("EMOTOR: TAKE=NIL for "..lastid.." ("..#tbl..")")
		take=""
	end
	if not last[lastid] then last[lastid]={} end
	last[lastid][take]=true
	return take
end

-- --------------------------------------------------------------------------------------
-- ADD TO TABLE
-- --------------------------------------------------------------------------------------
function Me:Add2Selectable(tbl,emosay,fromtbl,cmd,list,skipemotes)
	local lastid=emosay.."."..cmd.."."..list
	if not last[lastid] then last[lastid]={} end
	local excluded=0
	for nr,entry in pairs(fromtbl) do
		if (not entry.exclude or not entry.exclude[PLAYERNAME]) and (not entry.select or entry.select[PLAYERNAME]) then		
			if not last[lastid][entry.text] and (not skipemotes or string.sub(entry.text,1,1)~="/") then 
				tbl[1+#tbl]=entry  
			else 
				excluded=excluded+1
			end
		end
	end
	if #tbl<=1 then
		if excluded==0 or #tbl==0 then last[lastid]={} else last[lastid]={[tbl[1]]=true} end
	end
	return tbl
end

-- --------------------------------------------------------------------------------------
-- REPLACE KEYS WITH SEX
-- --------------------------------------------------------------------------------------
function Me:ReplaceKeysWithSex(text)
	local playersex=UnitSex("player")	
	local targetsex=playersex
	local targetname=playername
	local cursorsex=playersex
	local cursorname=playername
	-- Geschlecht des Targets ermitteln
	if UnitExists("target") then 
		targetname=UnitName("target")
		targetsex=UnitSex("target") 
		if targetsex==1 then targetsex=Me:GetSex(targetname,"target") end -- sächlich, ist default für alle Kreaturen
		targetname=Me:Peal(targetname,"target")
	end
	
	-- Geschlecht des Cursorziels ermitteln
	cursorname=getglobal("GameTooltipTextLeft1"):GetText()
	if cursorname==nil then 
		cursorname=targetname 
		cursorsex=targetsex
	else
		cursorsex=Me:GetSex(cursorname)
		cursorname=Me:Peal(cursorname,"cursor")
	end

	-- Namen im Text ersetzen
	text=(text or "")
	text=mod.f:Repl(text,{["*"]=playername,["."]=targetname,["#"]=cursorname})

	-- Schlüsselworte im Text ersetzen
	for key,repl in pairs(db.emotor.hesheit) do
		text=mod.f:Repl(text,{["*"..key]=repl[playersex],["."..key]=repl[targetsex],["#"..key]=repl[cursorsex]})
	end
	return text
end

-- --------------------------------------------------------------------------------------
-- GET SEX
-- --------------------------------------------------------------------------------------
function Me:GetSex(target,sexparm)
	local sex=1 -- Default ist sächlich
	local found=nil
	local word1,word2=strsplit(" ",strlower(target),2)
	if UnitName("pet")==target then
		sex=2 -- Pets sind normalerweise männlich, außer Sukkubus
		if UnitCreatureFamily("pet")==L.word.SUCCUBUS then sex=3 end
		found=true
	end
	
	if db.targets.list[target] and db.targets.list[target].player and db.targets.list[target].sex then
		sex=db.targets.list[target].sex
		found=true
	end
	
	-- vorangestellte Worte durchsuchen (z.B. Drache der ..., Akolyth der...)
	if word2 and not found then
		local search=L.emotor.sexprefix
		for i=1,#search,1 do
			if strfind(word1,search[i][2])==1 and not found then
				found="yes"
				sex=search[i][1]
			end
		end
		search=L.emotor.sexsufix
		for i=1,#search,1 do
			if strsub(word1,strlen(word1)-strlen(search[i][2])+1)==search[i][2] and not found then
				found="yes"
				sex=search[i][1]
			end
		end
	end
	
	-- Wortendungen durchsuchen
	word2=strlower(target)
	search=L.emotor.sexsufix
	for i=1,#search,1 do
		if strsub(word2,strlen(word2)-strlen(search[i][2])+1)==search[i][2] and not found then
			found="yes"
			sex=search[i][1]
		end
	end
	
	-- Letzte Wahl: Wenn es um "target" geht und das nicht als sächlich gekennzeichnet ist, DAS übernehmen
	if not found and sexparm=="target" and UnitSex("target")~=1 then
		sex=UnitSex("target") 
		found=sex
	end
	
	if not found then
		if not db.emotor.nosexfound[target] then mod.f:PrintR(L.msg.nosexfound,{target=target}) end
		if sexparm~="initcheck" then 
			if not db.emotor.nosexfound[target] then db.emotor.nosexfound[target]={last=0,count=0} end
			db.emotor.nosexfound[target]={last=time(),count=1+(db.emotor.nosexfound[target].count or 0)}
		end
	else
		if sexparm=="initcheck" then db.emotor.nosexfound[target]=nil end
	end
	if sexparm=="initcheck" then sex=found end
	return sex
end

-- --------------------------------------------------------------------------------------
-- GET SEX
-- --------------------------------------------------------------------------------------
function Me:Peal(name,target)
	if target then
		local word=mod.f:Split(name," ",4)
		if #word==4 then name=word[2]
		elseif #word==3 then name=word[1]
		elseif #word==2 then
			if UnitCanAttack("target","player") or target=="cursor" then name=word[2] end
		end
	else
	-- Suffix entfernen ("vorkommen", "pflanze", "ader"...)
		local erase=L.emotor.erasesufix
		for i=1,#erase,1 do
			if strsub(name,strlen(name)-strlen(erase[i])+1)==erase[i] then
				name=strsub(name,1,strlen(name)-strlen(erase[i]))
			end
		end
	end
	return name
end

-- --------------------------------------------------------------------------------------
-- MUTE
-- --------------------------------------------------------------------------------------
function Me:Mute(set,tovalue)
	local iconname="Interface/AddOns/Zifnabs/Icons/Buttons/"
	if set~="set" then tovalue=(not db.emotor.muted) end
	db.emotor.muted=tovalue
	if tovalue then 
		iconname=iconname.."muted.tga" 
		widget.mute.tooltipText=L.msg.muted
	else 
		iconname=iconname.."unmuted.tga" 
		widget.mute.tooltipText=L.msg.unmuted
	end
	widget.mute:SetNormalTexture(iconname)
end

-- --------------------------------------------------------------------------------------
-- --------------------------------------------------------------------------------------

-- --------------------------------------------------------------------------------------
-- IDENTIFY CONFIG FRAMES
-- --------------------------------------------------------------------------------------
function Me:IdentifyConfigs() return {[1]=L.config.emotor,[2]=L.config.emotorkeys} end

-- --------------------------------------------------------------------------------------
-- START CONFIG
-- --------------------------------------------------------------------------------------
function Me:StartConfig(frame)
	if not config then config={} end
	if config.snr~=frame.section.snr then config.top=nil end -- indicates frame change
	config.snr=frame.section.snr
	config.changed=false
	if config.snr==1 then Me:StartConfigActions(frame)
	elseif config.snr==2 then Me:StartConfigKeys(frame)
	end
end
function Me:StartConfigActions(frame)
--	db.emotor.cmd[cmd]={option={order=1,react={},mute={},desc="Gruß",summon=IMP|VOID...,chain=SUMMON_DEMON},["NOTARGET"]={say={{text=""}}}}
	if not widget.cactions then
		widget.cactions={cmd={},tgt={},text={},tselmode={},tselect={}}
		-- Command Buttons
		for y=1,5,1 do for x=1,3,1 do
			local nr=3*y+x-3
			widget.cactions.cmd[nr]=mod.ui:newButton(myname.."_Cmd_"..nr,180,20,frame,"TOPLEFT","TOPLEFT",190*x-180,10-20*y,{click=Me.ButtonSelectCmd})
			widget.cactions.cmd[nr].selection=nr
		end end
		widget.cactions.cmdup=mod.ui:newButton(myname.."_CmdUp",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-10,{click=Me.ScrollUpCmds,text="^"})
		widget.cactions.cmddown=mod.ui:newButton(myname.."_CmdDown",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-90,{click=Me.ScrollDownCmds,text="v"})
		widget.cactions.react=mod.ui:newSlider(myname.."_Opt_React",200,20,frame,"TOPLEFT","TOPLEFT",10,-125,{min=0,max=100,val=0,text=L.word.percentreact,click=Me.InputChanged,tt=L.msg.ttreact})
		widget.cactions.mute=mod.ui:newSlider(myname.."_Opt_Mute",200,20,frame,"TOPLEFT","TOPLEFT",240,-125,{min=0,max=600,val=0,text=L.word.mute,click=Me.InputChanged,tt=L.msg.ttmute})
		-- Target Buttons
		local word={[1]="NOTARGET",[2]="TARGET",[3]="KNOWN",[4]="PAL",[5]="ENEMY"}
		for t=1,5,1 do
			widget.cactions.tgt[t]=mod.ui:newButton(myname.."_Tgt_"..t,90,20,frame,"TOPLEFT","TOPLEFT",100*t-90,-180,{click=Me.ButtonSelectTarget,text=(L.word[word[t]] or word[t])})
			widget.cactions.tgt[t].selection={nr=t,target=word[t]}
		end
		-- Say & Emote
		widget.cactions.say=mod.ui:newButton(myname.."_Say",90,20,frame,"TOPLEFT","TOPLEFT",10,-205,{click=Me.ButtonSelectEmoSay,text=L.word.SAY})
		widget.cactions.say.selection="say"
		widget.cactions.emo=mod.ui:newButton(myname.."_Emo",90,20,frame,"TOPLEFT","TOPLEFT",110,-205,{click=Me.ButtonSelectEmoSay,text=L.word.EMO})
		widget.cactions.emo.selection="emo"
		-- Texte
		for t=1,12,1 do
			widget.cactions.text[t]=mod.ui:newEditBox(myname.."_Text_"..t,500,18,frame,"TOPLEFT","TOPLEFT",60,-210-20*t,{onchange=Me.InputChanged})
			widget.cactions.text[t].selection=t
			widget.cactions.tselect[t]=mod.ui:newCheck(myname.."_Text_Select_"..t,20,20,frame,"TOPLEFT","TOPLEFT",30,-210-20*t,{click=Me.ButtonSelectText})
			widget.cactions.tselect[t].selection=t
			widget.cactions.tselmode[t]=mod.ui:newButton(myname.."_Text_Mode_"..t,20,20,frame,"TOPLEFT","TOPLEFT",10,-210-20*t,{click=Me.ButtonSelectTextMode})
			widget.cactions.tselmode[t].selection=t
		end
		widget.cactions.txtup=mod.ui:newButton(myname.."_TxtUp",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-230,{click=Me.ScrollUpTexts,text="^"})
		widget.cactions.txtdown=mod.ui:newButton(myname.."_TxtDown",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-450,{click=Me.ScrollDownTexts,text="v"})
	end
	local temp={hi=0}
	for cmd,list in pairs(db.emotor.cmd) do 
		temp[list.option.order]={cmd=cmd,list=mod.f:CopyTable(list),original=mod.f:CopyTable(list)} 
		temp.hi=math.max(temp.hi,list.option.order)
	end
	config.cmds={}
	for nr=1,temp.hi,1 do
		if temp[nr] then config.cmds[1+#config.cmds]={cmd=temp[nr].cmd,list=temp[nr].list,original=temp[nr].original} end
	end
	if not config.top then
		config.top={cmd=1,txt=1}
		config.selected={cmd=1,tgt="NOTARGET",es="say"}
	end
	Me:ShowSelection()
end
function Me:StartConfigKeys(frame)
--	db.emotor.hesheit[key]={"dieses","dieser","diese"}
	if not widget.ckeys then
		widget.ckeys={key={},he={},she={},it={}}
		widget.ckeys.up=mod.ui:newButton(myname.."_Up",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-10,{click=Me.ScrollUpKeys,text="^"})
		widget.ckeys.down=mod.ui:newButton(myname.."_Down",20,20,frame,"TOPRIGHT","TOPRIGHT",-4,-390,{click=Me.ScrollDownKeys,text="v"})
		for n=1,20,1 do
			widget.ckeys.key[n]=mod.ui:newEditBox(myname.."_Key_"..n,90,20,frame,"TOPLEFT","TOPLEFT",10,10-20*n,{onchange=Me.InputChanged})
			widget.ckeys.he[n]=mod.ui:newEditBox(myname.."_He_"..n,90,20,frame,"TOPLEFT","TOPLEFT",110,10-20*n,{onchange=Me.InputChanged})
			widget.ckeys.she[n]=mod.ui:newEditBox(myname.."_She_"..n,90,20,frame,"TOPLEFT","TOPLEFT",210,10-20*n,{onchange=Me.InputChanged})
			widget.ckeys.it[n]=mod.ui:newEditBox(myname.."_It_"..n,90,20,frame,"TOPLEFT","TOPLEFT",310,10-20*n,{onchange=Me.InputChanged})
		end
	end
	config.keys={}
	for key,list in pairs(db.emotor.hesheit) do config.keys[1+#config.keys]={key=key,list={list[1],list[2],list[3]},originalkey=key,originallist=list} end
	if not config.top then config.top=1 end
	Me:ScrollKeys(0)
end

function Me:ButtonSelectCmd(button) 
	local tgt=config.selected.tgt
	if not config.cmds[button.selection+config.top.cmd-1] then
		-- TODO neuer Command
	end
	if not config.cmds[button.selection+config.top.cmd-1].list[tgt] then
		if config.cmds[button.selection+config.top.cmd-1].list["NOTARGET"] then tgt="NOTARGET" else tgt="TARGET" end
	end
	Me:ShowSelection(button.selection,tgt,nil) 
end
function Me:ButtonSelectTarget(button) Me:ShowSelection(nil,button.selection.target,nil) end
function Me:ButtonSelectEmoSay(button) Me:ShowSelection(nil,nil,button.selection) end
function Me:ScrollUpCmds() Me:ShowSelection(nil,nil,nil,-3) end
function Me:ScrollDownCmds() Me:ShowSelection(nil,nil,nil,3) end
function Me:ScrollUpTexts() Me:ShowSelection(nil,nil,nil,nil,-1) end
function Me:ScrollDownTexts() Me:ShowSelection(nil,nil,nil,nil,1) end
function Me:ButtonSelectTextMode(button)
	local nr=config.top.txt+button.selection-1
	local entry=config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es][nr]
	-- switch from select to exclude mode
	if entry.select then
		if not entry.select[PLAYERNAME] then
			entry.exclude={[PLAYERNAME]=true}
		end
		entry.select=nil
		button:SetText("x")
	-- switch from exclude to select mode
	else
		entry.select={}
		if not entry.exclude or not entry.exclude[PLAYERNAME] then
			entry.select={[PLAYERNAME]=true}
		end
		entry.exclude=nil
		button:SetText("s")
	end
	Me:InputChanged()
end
function Me:ButtonSelectText(button) 
	local nr=config.top.txt+button.selection-1
	local entry=config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es][nr]
	if entry.select then entry.select[PLAYERNAME]=button:GetChecked()
	else
		if not entry.exclude then entry.exclude={} end
		entry.exclude[PLAYERNAME]=(not button:GetChecked())
	end
	Me:InputChanged()
end

-- --------------------------------------------------------------------------------------
-- SHOW EMOTOR SELECTION
-- --------------------------------------------------------------------------------------
function Me:ShowSelection(scmd,stgt,es,cmdscroll,txtscroll)
	config.setup=false
	if scmd or stgt or ed then
		config.setup=mod.core:HandleChanges()
		if not config.setup then
			scmd=nil
			stgt=nil
			es=nil
		end
	end
	if scmd then config.selected.cmd=scmd+config.top.cmd-1 end
	if stgt then config.selected.tgt=stgt end
	if es then config.selected.es=es end
	config.top.cmd=math.max(1,config.top.cmd+(cmdscroll or 0))
	if config.top.cmd==1 then widget.cactions.cmdup:Hide() else widget.cactions.cmdup:Show() end
	if config.top.cmd+14>#config.cmds then widget.cactions.cmddown:Hide() else widget.cactions.cmddown:Show() end
	config.top.txt=math.max(1,config.top.txt+(txtscroll or 0))
	if config.top.txt==1 then widget.cactions.txtup:Hide() else widget.cactions.txtup:Show() end
	if config.top.txt+12>#config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es] then widget.cactions.txtdown:Hide() else widget.cactions.txtdown:Show() end

	-- Command buttons
	for b=1,15,1 do
		local nr=b+config.top.cmd-1
		if nr>#config.cmds then widget.cactions.cmd[b]:Hide()
		else
			widget.cactions.cmd[b]:SetText(config.cmds[nr].list.option.desc or config.cmds[nr].cmd)
			widget.cactions.cmd[b]:Show()
			if nr==config.selected.cmd then widget.cactions.cmd[b]:Disable() else widget.cactions.cmd[b]:Enable() end
		end
	end
	-- Target Buttons
	local data=config.cmds[config.selected.cmd].list
	for t=1,5,1 do
		local target=widget.cactions.tgt[t].selection.target
		if target==config.selected.tgt then widget.cactions.tgt[t]:Disable() else widget.cactions.tgt[t]:Enable() end
		if data[target] then widget.cactions.tgt[t]:Show() else widget.cactions.tgt[t]:Hide() end
	end
	-- Say und Emote
	if config.selected.es=="say" then widget.cactions.say:Disable() else widget.cactions.say:Enable() end
	if config.selected.es=="emo" then widget.cactions.emo:Disable() else widget.cactions.emo:Enable() end
	-- Options
	-- Texte
	for t=1,12,1 do
		local text=""
		local mode="x"
		local sel=false
		if data[config.selected.tgt] and data[config.selected.tgt][config.selected.es][t+config.top.txt-1] then 
			local entry=data[config.selected.tgt][config.selected.es][t+config.top.txt-1]
			text=entry.text
			if entry.select then mode="s" end
			if (not entry.exclude or not entry.exclude[PLAYERNAME]) and (not entry.select or entry.select[PLAYERNAME]) then sel=true end
		end
		widget.cactions.text[t]:SetText(text)
		widget.cactions.tselmode[t]:SetText(mode)
		widget.cactions.tselmode[t].tooltipText=L.msg["tselmode"..mode]
		widget.cactions.tselect[t]:SetChecked(sel)
	end
	widget.cactions.react:SetValue(data.option.react[PLAYERNAME] or data.option.react.default or 100)
	widget.cactions.mute:SetValue(data.option.mute[PLAYERNAME] or data.option.mute.default or 0)
	config.setup=false
end

-- --------------------------------------------------------------------------------------
-- KEY PRESSED 
-- --------------------------------------------------------------------------------------
function Me:InputChanged(editfield,key)
	-- check for changes in cmds
	if config.snr==1 then
		config.changed=false
		local react=widget.cactions.react:GetValue()
		local mute=widget.cactions.mute:GetValue()
		local option=config.cmds[config.selected.cmd].list.option
		if react==option.react.default then option.react[PLAYERNAME]=nil else option.react[PLAYERNAME]=react end
		if mute==option.mute.default then option.mute[PLAYERNAME]=nil else option.mute[PLAYERNAME]=mute end
		if option.react[PLAYERNAME]~=config.cmds[config.selected.cmd].original.option.react[PLAYERNAME] then config.changed=true end
		if option.mute[PLAYERNAME]~=config.cmds[config.selected.cmd].original.option.mute[PLAYERNAME] then config.changed=true end
		-- TODO check for new commands ... auch original muss dann mit "Leercmd" angepasst werden
		for t=1,12,1 do
			local nr=config.top.txt+t-1
			local entry=config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es][nr]
			local original=config.cmds[config.selected.cmd].original[config.selected.tgt][config.selected.es][nr]
			if editfield and t==editfield.selection and not entry then
				config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es][nr]={}
				config.cmds[config.selected.cmd].original[config.selected.tgt][config.selected.es][nr]={}
				widget.cactions.tselect[t]:SetChecked(true)
				config.changed=true
			end
			if entry and not original then config.changed=true -- should never happen
			elseif entry then
				if (entry.select and not original.select) or (entry.exclude and not original.exclude) then config.changed=true
				elseif entry.select and not Me:EqualXS(entry.select,original.select) then config.changed=true
				elseif entry.exclude and not Me:EqualsXS(entry.exclude,original.exclude) then config.changed=true
				end
				local text=mod.f:Trim(widget.cactions.text[t]:GetText())
				entry.text=text
				if text~=original.text then config.changed=true end
			end
		end
	-- check for changes in hesheit
	elseif config.snr==2 then
		local parse=mod.f:Split(editfield:GetName(),"_")
		local nr=tonumber(parse[#parse])+config.top-1
		local what=parse[#parse-1]
		local content=mod.f:Trim(editfield:GetText() or "")
		if not config.keys[nr] and content~="" then config.keys[nr]={key=nil,list={}, originallist={}} end
		if what=="Key" then config.keys[nr].key=content
		elseif what=="He" then config.keys[nr].list[1]=content
		elseif what=="She" then config.keys[nr].list[2]=content
		elseif what=="It" then config.keys[nr].list[3]=content
		end
		config.changed=false
		for nr=1,#config.keys,1 do
			local entry=config.keys[nr]
			if (entry.key or "")~=(entry.originalkey or "") then config.changed=true end
			for l=1,3,1 do
				if (entry.list[l] or "")~=(entry.originallist[l] or "") then config.changed=true end
			end
		end
	end
	if config.setup then config.changed=false end
	mod.core:SetUnsavedChanges(config.changed)
end
function Me:EqualsXS(tbl1,tbl2)
	local equal=true
	local check=mod.f:CopyTable(tbl2)
	for key,data in pairs(tbl1) do
		if check[key]==nil or data~=tbl2[key] then equal=false end
		check[key]=nil
	end
	for key,data in pairs(check) do
		if data~=nil then equal=false end
	end
	return equal
end

-- --------------------------------------------------------------------------------------
-- SCROLL
-- --------------------------------------------------------------------------------------
function Me:ScrollUpKeys() Me:ScrollKeys(-1) end
function Me:ScrollDownKeys() Me:ScrollKeys(1) end
function Me:ScrollKeys(by)
	config.top=math.max(1,math.min(#config.keys-18,config.top+by))
	if config.top==1 then widget.ckeys.up:Hide() else widget.ckeys.up:Show() end
	if config.top>=#config.keys-18 then widget.ckeys.down:Hide() else widget.ckeys.down:Show() end
	for nr=1,20,1 do
		local entry=config.keys[config.top+nr-1] or {list={}}
		widget.ckeys.key[nr]:SetText(entry.key or "")
		widget.ckeys.he[nr]:SetText(entry.list[1] or "")
		widget.ckeys.she[nr]:SetText(entry.list[2] or "")
		widget.ckeys.it[nr]:SetText(entry.list[3] or "")
		if config.top+nr-1>#config.keys+1 then
			widget.ckeys.key[nr]:Hide()
			widget.ckeys.he[nr]:Hide()
			widget.ckeys.she[nr]:Hide()
			widget.ckeys.it[nr]:Hide()
		else
			widget.ckeys.key[nr]:Show()
			widget.ckeys.he[nr]:Show()
			widget.ckeys.she[nr]:Show()
			widget.ckeys.it[nr]:Show()
		end
	end
end

-- --------------------------------------------------------------------------------------
-- SAVE CONFIG
-- --------------------------------------------------------------------------------------
function Me:SaveConfig(frame)
	if config.snr==1 then
		local cmd=config.cmds[config.selected.cmd].cmd
		local list={}
		for n,entry in pairs(config.cmds[config.selected.cmd].list[config.selected.tgt][config.selected.es]) do
			if entry.text and entry.text~="" then list[1+#list]=entry end
		end
		db.emotor.cmd[cmd][config.selected.tgt][config.selected.es]=list		
		db.emotor.cmd[cmd].option=mod.f:CopyTable(config.cmds[config.selected.cmd].list.option)
	elseif config.snr==2 then
		local hesheit={}
		for n=1,#config.keys,1 do
			if (config.keys[n].key or "")~="" then
				local list=config.keys[n].list
				hesheit[config.keys[n].key]={[1]=list[1],[2]=list[2],[3]=list[3]}
			end
		end
		db.emotor.hesheit=hesheit
	end
	Me:StartConfig(frame)
	return true
end

-- --------------------------------------------------------------------------------------
-- IGNORE CONFIG
-- --------------------------------------------------------------------------------------
function Me:IgnoreConfig(frame) 
	Me:StartConfig(frame)
	return true 
end